/*
**	Anderson Ferminiano
**	contato@andersonferminiano.com -- feel free to contact me for bugs or new implementations.
**	jQuery ScrollPagination
**	28th/March/2011
**	http://andersonferminiano.com/jqueryscrollpagination/
**	You may use this script for free, but keep my credits.
**	Thank you.
*/

(function ($) {


    $.fn.scrollPagination = function (options) {
        var opts = $.extend($.fn.scrollPagination.defaults, options);
        var target = opts.scrollTarget;
        if (target == null) {
            target = obj;
        }
        opts.scrollTarget = target;

        return this.each(function () {
            $.fn.scrollPagination.init($(this), opts);
        });

    };

    $.fn.stopScrollPagination = function () {
        return this.each(function () {
            $(this).attr('scrollPagination', 'disabled');
        });

    };

    $.fn.scrollPagination.loadContent = function (obj, opts, isFirst) {
        var target = opts.scrollTarget;
        var triggerView = opts.triggerView;

        var mayLoadContent = $.fn.scrollPagination.GetVisible(obj, opts);

        if (opts.debug) {
            var offset = $(triggerView).offset();
            var $window = $(window);
            var $monitor = $('#monitor');
            var debugContent = "<b>Offset top:</b> " + offset.top + "<br><b>ScrollTop:</b> " + $window.scrollTop() +
                        "<br><b>Offset left:</b> " + offset.left + "<br><b>ScrollLeft:</b> " + $window.scrollLeft() +
                        "<br><b>ScrollTop + Window:</b> " + ($window.scrollTop() + $window.height()) +
                        "<br><b>ScrollLeft + Window:</b> " + ($window.scrollLeft() + $window.width()) +
                        "<br><b>document height:</b> " + $(document).height() +
                        "<br><b>Will trigger:</b> " + mayLoadContent;
            if ($monitor.length == 0) {
                $(document.body).append("<div id='monitor' style='position: absolute; top: 10px; left: 10px; padding: 1em; color: white; background-color: black'>" + debugContent + "</div>");
            } else {
                $monitor.css("top", $window.scrollTop() + 10 + "px").html(debugContent);
            }
        }

        if (mayLoadContent || isFirst) {
            if (opts.loading) {
                return;         // ڼݣȡǰжظأ
            }
            opts.loading = true;
            if (opts.beforeLoad != null) {
                opts.beforeLoad(obj, opts);
            }
            // $(obj).children().attr('rel', 'loaded');         // ҪƵⲿȥִС
            $.ajax({
                async: true,
                type: opts.method,
                url: opts.contentPage,
                data: opts.contentData,
                success: function (data) {
                    if (opts.loadData != null) {
                        opts.loadData(obj, data);       // ⲿȥݡ
                    }
                    // var objectsRendered = $(obj).children('[rel!=loaded]');  // ҪƵⲿȥִС

                    if (opts.afterLoad != null) {
                        opts.afterLoad(obj, data);      // objΪӵĶdataΪݡ
                    }
                    opts.loading = false;

                    // ûгĻݡ
                    if (data == null || data == "") {
                    } else {
                        mayLoadContent = $.fn.scrollPagination.GetVisible(obj, opts);
                        if (mayLoadContent) {
                            $.fn.scrollPagination.loadContent(obj, opts, false);
                        }
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    opts.loading = false;
                    if (opts.onerror != null) {
                        opts.onerror(textStatus, errorThrown);
                    }
                },
                dataType: opts.dataType
            });
        }

    };

    $.fn.scrollPagination.init = function (obj, opts) {
        var target = opts.scrollTarget;
        $(obj).attr('scrollPagination', 'enabled');

        $(target).scroll(function (event) {
            if ($(obj).attr('scrollPagination') == 'enabled') {
                $.fn.scrollPagination.loadContent(obj, opts, false);
            }
            else {
                event.stopPropagation();
            }
        });

        $.fn.scrollPagination.loadContent(obj, opts, true);

    };

    // scrolling view is in visible area.
    $.fn.scrollPagination.GetVisible = function (obj, opts) {
        var target = opts.scrollTarget;
        var triggerView = opts.triggerView;

        var mayLoadContent = $(target).scrollTop() + opts.heightOffset >= $(document).height() - $(target).height();

        var vh = triggerView.offset().top + opts.heightOffset;
        var wt = target.scrollTop();
        mayLoadContent = (vh >= wt && vh < target.height() + wt)        // in visible area.
        if (mayLoadContent) {
            return true;
        }
        return false;
    };

    $.fn.scrollPagination.defaults = {
        'contentPage': null,
        'method': 'POST',
        'dataType': 'html',
        'contentData': {},
        'beforeLoad': null,
        'loadData': null,
        'afterLoad': null,
        'onerror': null,
        'scrollTarget': null,
        'triggerView': null,
        'heightOffset': 0,
        'debug': false,
        'loading': false
    };
})(jQuery);