﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;

namespace ScrollPagerWeb
{
	/// <summary>
	/// Summary description for Test
	/// </summary>
	public class Test : IHttpHandler
	{

		public void ProcessRequest(HttpContext context)
		{
			HttpRequest request = context.Request;
			HttpResponse response = context.Response;
			context.Response.ContentType = "text/plain";
			int pageIndex = GetPageIndex(request);

			List<Member> clist = GetMembers();

			List<Member> list = clist.Skip(10 * (pageIndex - 1)).Take(10).ToList();

			response.Write(GernateHTML(list));

		}

		public bool IsReusable
		{
			get
			{
				return false;
			}
		}

		private List<Member> GetMembers()
		{
			List<Member> list = new List<Member>();

			for (int i = 0; i < 100000; i++)
			{
				Member member = new Member()
				{
					Name = "Name" + i,
					IDNo = "IDNo" + i,
					MemberNo = "MemberNo" + i
				};
				list.Add(member);
			}

			return list;
		}

		private static int GetPageIndex(HttpRequest request)
		{
			int pageIndex = 1;
			string index = request.Form["pageIndex"];
			int.TryParse(index, out pageIndex);

			return pageIndex;
		}

		private static string GernateHTML(List<Member> list)
		{
			if (list == null || list.Count == 0) return string.Empty;

			StringBuilder sb = new StringBuilder();

			foreach (var item in list)
			{
				//<!-- 列表栏位 -->
				sb.Append(String.Format("<table id='tb{0}' width='100%' border='0' cellpadding='0' cellspacing='0' class='BgInteListGray'>", item.IDNo));
				sb.Append("<tr>");
				sb.Append(String.Format("<td width='50' height='50'>{0}</td>", item.Name));
				sb.Append(String.Format("<td width='111'  valign='top'>{0}</td>", item.MemberNo));
				sb.Append("</tr></table>");
			}
			return sb.ToString();
		}

		public class Member
		{
			public string IDNo { get; set; }

			public string Name { get; set; }

			public string MemberNo { get; set; }
		}
	}
}